=== modified file 'NEWS'
--- NEWS	2010-07-04 06:22:11 +0000
+++ NEWS	2010-07-13 21:25:03 +0000
@@ -5,11 +5,94 @@
 .. contents:: List of Releases
    :depth: 1
 
+bzr 2.3b1
+#########
+
+:Codename: ???
+:2.3b1: NOT RELEASED YET
+
+Compatibility Breaks
+********************
+
+New Features
+************
+
+Bug Fixes
+*********
+
+Improvements
+************
+
+Documentation
+*************
+
+API Changes
+***********
+
+Internals
+*********
+
+Testing
+*******
+
+
+bzr 2.2rc1
+##########
+
+:Codename: ???
+:2.2rc1: NOT RELEASED YET
+
+Compatibility Breaks
+********************
+
+New Features
+************
+
+Bug Fixes
+*********
+
+* Configuration files in ``${BZR_HOME}`` are now written in an atomic
+  way which should help avoid problems with concurrent writers.
+  (Vincent Ladeuil, #525571)
+
+* Don't traceback trying to unversion children files of an already
+  unversioned directory.  (Vincent Ladeuil, #494221)
+
+Improvements
+************
+
+Documentation
+*************
+
+API Changes
+***********
+
+Internals
+*********
+
+Testing
+*******
+
+
 bzr 2.2b4
 #########
 
 :Codename: Monkey Magic
-:2.2b4: NOT RELEASED YET
+:2.2b4: 2004-07-09
+
+
+This fourth and final beta in the 2.2 series now stabilizes the internal
+APIs. Plugin authors are recommended to ensure their releases are
+compatible, so that 2.2rc1 can be a true release candidate, containing
+stable and compatible plugin versions. 
+
+For users of bzrlib as a library, one of the primary changes is to request
+that they call ``bzrlib.initialize`` and use the returned context manager
+appropriately.
+
+Better interaction with ``bzr-loom`` to make sure branching from a loom
+even over a smart server still yields a local loom. Not to mention lots of
+bugfixes over 2.2b3.
 
 Compatibility Breaks
 ********************
@@ -26,7 +109,7 @@
   is such a manager, but third party UI factories which do not derive from
   ``bzrlib.ui.UIFactory`` will be incompatible with the command line front
   end.
-  
+
 * URLs like ``foo:bar/baz`` are now always parsed as a URL with scheme "foo"
   and path "bar/baz", even if bzr does not recognize "foo" as a known URL
   scheme.  Previously these URLs would be treated as local paths.
@@ -87,6 +170,10 @@
   test that all commands available to the test suite have help.
   (Robert Collins, #177500)
 
+* Invalid patterns supplied to ``Globster`` or ``lazy_regex`` now raise
+  ``InvalidPattern`` exception showing clear error message to the user.
+  (Parth Malwankar #300062)
+
 * Progress output is cleaned up when exiting.  (Aaron Bentley)
 
 * Raise ValueError instead of a string exception.
@@ -175,6 +262,11 @@
   2007, has been deleted.  Use ``PatienceSequenceMatcher`` from
   ``bzrlib.patiencediff`` instead. (Andrew Bennetts)
 
+* ``bzrlib.re_compile_checked`` is now deprecated. Caller should handle
+  ``bzrlib.errors.InvalidPattern`` exception thrown by ``re.match`` in
+  case the default error message not suitable for the use case.
+  (Parth Malwankar)
+
 * ``bzrlib.tests.blackbox.ExternalBase`` is deprecated.  It provided only
   one method ``check_output``, and we now recommend checking command
   output using ``run_script``. (Martin Pool)
@@ -934,6 +1026,13 @@
 Bug Fixes
 *********
 
+* Configuration files in ``${BZR_HOME}`` are now written in an atomic
+  way which should help avoid problems with concurrent writers.
+  (Vincent Ladeuil, #525571)
+
+* Don't traceback trying to unversion children files of an already
+  unversioned directory.  (Vincent Ladeuil, #494221)
+
 * Raise ValueError instead of a string exception.
   (John Arbash Meinel, #586926)
 
@@ -1447,6 +1546,9 @@
   permissions as ``.bzr`` directory on a POSIX OS.
   (Parth Malwankar, #262450)
 
+* Don't traceback trying to unversion children files of an already
+  unversioned directory.  (Vincent Ladeuil, #494221)
+
 * Raise ValueError instead of a string exception.
   (John Arbash Meinel, #586926)
 

=== modified file 'bzr'
--- bzr	2010-06-22 22:40:29 +0000
+++ bzr	2010-07-13 07:44:02 +0000
@@ -23,7 +23,7 @@
 import warnings
 
 # update this on each release
-_script_version = (2, 2, 0)
+_script_version = (2, 3, 0)
 
 try:
     version_info = sys.version_info

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2010-07-02 22:44:00 +0000
+++ bzrlib/__init__.py	2010-07-13 07:44:02 +0000
@@ -52,7 +52,7 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (2, 2, 0, 'beta', 3)
+version_info = (2, 3, 0, 'dev', 1)
 
 # API compatibility version
 api_minimum_version = (2, 2, 0)

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2010-06-02 04:50:35 +0000
+++ bzrlib/config.py	2010-07-13 16:10:20 +0000
@@ -74,6 +74,7 @@
 
 import bzrlib
 from bzrlib import (
+    atomicfile,
     debug,
     errors,
     mail_client,
@@ -478,12 +479,10 @@
         return self.get_user_option('nickname')
 
     def _write_config_file(self):
-        f = file(self._get_filename(), "wb")
-        try:
-            osutils.copy_ownership_from_path(f.name)
-            self._get_parser().write(f)
-        finally:
-            f.close()
+        atomic_file = atomicfile.AtomicFile(self._get_filename())
+        self._get_parser().write(atomic_file)
+        atomic_file.commit()
+        atomic_file.close()
 
 
 class GlobalConfig(IniBasedConfig):

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2010-06-17 11:52:13 +0000
+++ bzrlib/errors.py	2010-07-09 16:16:11 +0000
@@ -3155,4 +3155,10 @@
         "Please, set your name with the 'whoami' command.\n"
         'E.g. bzr whoami "Your Name <name@example.com>"')
 
+class InvalidPattern(BzrError):
+
+    _fmt = ('Invalid pattern(s) found. %(msg)s')
+
+    def __init__(self, msg):
+        self.msg = msg
 

=== modified file 'bzrlib/globbing.py'
--- bzrlib/globbing.py	2010-02-17 17:11:16 +0000
+++ bzrlib/globbing.py	2010-07-09 16:16:11 +0000
@@ -22,8 +22,10 @@
 
 import re
 
+from bzrlib import errors
 from bzrlib.trace import (
-    warning
+    mutter,
+    warning,
     )
 
 
@@ -209,10 +211,18 @@
 
         :return A matching pattern or None if there is no matching pattern.
         """
-        for regex, patterns in self._regex_patterns:
-            match = regex.match(filename)
-            if match:
-                return patterns[match.lastindex -1]
+        try:
+            for regex, patterns in self._regex_patterns:
+                match = regex.match(filename)
+                if match:
+                    return patterns[match.lastindex -1]
+        except errors.InvalidPattern, e:
+            # We can't show the default e.msg to the user as thats for
+            # the combined pattern we sent to regex. Instead we indicate to
+            # the user that an ignore file needs fixing.
+            mutter('Invalid pattern found in regex: %s.', e.msg)
+            e.msg = "File ~/.bazaar/ignore or .bzrignore contains errors."
+            raise e
         return None
 
 class ExceptionGlobster(object):

=== modified file 'bzrlib/help_topics/en/configuration.txt'
--- bzrlib/help_topics/en/configuration.txt	2010-06-21 22:29:38 +0000
+++ bzrlib/help_topics/en/configuration.txt	2010-07-06 01:26:59 +0000
@@ -179,6 +179,15 @@
 The path where Bazaar should look for shell plugin external commands.
 
 
+http_proxy, https_proxy
+~~~~~~~~~~~~~~~~~~~~~~~
+
+Specifies the network proxy for outgoing connections, for example::
+
+  http_proxy=http://proxy.example.com:3128/ 
+  https_proxy=http://proxy.example.com:3128/
+
+
 Configuration files
 -------------------
 

=== modified file 'bzrlib/lazy_regex.py'
--- bzrlib/lazy_regex.py	2009-03-23 14:59:43 +0000
+++ bzrlib/lazy_regex.py	2010-06-30 12:03:30 +0000
@@ -22,6 +22,8 @@
 
 import re
 
+from bzrlib import errors
+
 
 class LazyRegex(object):
     """A proxy around a real regex, which won't be compiled until accessed."""
@@ -58,7 +60,12 @@
 
     def _real_re_compile(self, *args, **kwargs):
         """Thunk over to the original re.compile"""
-        return _real_re_compile(*args, **kwargs)
+        try:
+            return _real_re_compile(*args, **kwargs)
+        except re.error, e:
+            # raise InvalidPattern instead of re.error as this gives a
+            # cleaner message to the user.
+            raise errors.InvalidPattern('"' + args[0] + '" ' +str(e))
 
     def __getattr__(self, attr):
         """Return a member from the proxied regex object.

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2010-06-17 08:53:15 +0000
+++ bzrlib/log.py	2010-06-30 12:03:30 +0000
@@ -86,7 +86,6 @@
     format_date,
     format_date_with_offset_in_original_timezone,
     get_terminal_encoding,
-    re_compile_checked,
     terminal_width,
     )
 from bzrlib.symbol_versioning import (
@@ -811,8 +810,7 @@
     """
     if search is None:
         return log_rev_iterator
-    searchRE = re_compile_checked(search, re.IGNORECASE,
-            'log message filter')
+    searchRE = re.compile(search, re.IGNORECASE)
     return _filter_message_re(searchRE, log_rev_iterator)
 
 

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2010-07-04 07:48:25 +0000
+++ bzrlib/osutils.py	2010-07-09 16:16:11 +0000
@@ -2163,6 +2163,7 @@
             raise
 
 
+@deprecated_function(deprecated_in((2, 2, 0)))
 def re_compile_checked(re_string, flags=0, where=""):
     """Return a compiled re, or raise a sensible error.
 
@@ -2178,12 +2179,12 @@
         re_obj = re.compile(re_string, flags)
         re_obj.search("")
         return re_obj
-    except re.error, e:
+    except errors.InvalidPattern, e:
         if where:
             where = ' in ' + where
         # despite the name 'error' is a type
-        raise errors.BzrCommandError('Invalid regular expression%s: %r: %s'
-            % (where, re_string, e))
+        raise errors.BzrCommandError('Invalid regular expression%s: %s'
+            % (where, e.msg))
 
 
 if sys.platform == "win32":

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-07-04 06:22:11 +0000
+++ bzrlib/tests/__init__.py	2010-07-08 10:34:12 +0000
@@ -2744,8 +2744,7 @@
     :param pattern: A regular expression string.
     :return: A callable that returns True if the re matches.
     """
-    filter_re = osutils.re_compile_checked(pattern, 0,
-        'test filter')
+    filter_re = re.compile(pattern, 0)
     def condition(test):
         test_id = test.id()
         return filter_re.search(test_id)

=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2010-06-25 08:01:24 +0000
+++ bzrlib/tests/blackbox/test_log.py	2010-07-09 16:16:11 +0000
@@ -381,16 +381,14 @@
 
     def test_log_bad_message_re(self):
         """Bad --message argument gives a sensible message
-        
+
         See https://bugs.launchpad.net/bzr/+bug/251352
         """
         self.make_minimal_branch()
         out, err = self.run_bzr(['log', '-m', '*'], retcode=3)
-        self.assertEqual("bzr: ERROR: Invalid regular expression"
-            " in log message filter"
-            ": '*'"
-            ": nothing to repeat\n", err)
-        self.assertEqual('', out)
+        self.assertContainsRe(err, "ERROR.*Invalid pattern.*nothing to repeat")
+        self.assertNotContainsRe(err, "Unprintable exception")
+        self.assertEqual(out, '')
 
     def test_log_unsupported_timezone(self):
         self.make_linear_branch()

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2010-04-07 21:34:13 +0000
+++ bzrlib/tests/blackbox/test_status.py	2010-06-24 06:57:31 +0000
@@ -704,16 +704,6 @@
 
 class TestStatusEncodings(TestCaseWithTransport):
 
-    def setUp(self):
-        TestCaseWithTransport.setUp(self)
-        self.user_encoding = osutils._cached_user_encoding
-        self.stdout = sys.stdout
-
-    def tearDown(self):
-        osutils._cached_user_encoding = self.user_encoding
-        sys.stdout = self.stdout
-        TestCaseWithTransport.tearDown(self)
-
     def make_uncommitted_tree(self):
         """Build a branch with uncommitted unicode named changes in the cwd."""
         working_tree = self.make_branch_and_tree(u'.')
@@ -727,8 +717,7 @@
         return working_tree
 
     def test_stdout_ascii(self):
-        sys.stdout = StringIO()
-        osutils._cached_user_encoding = 'ascii'
+        self.overrideAttr(osutils, '_cached_user_encoding', 'ascii')
         working_tree = self.make_uncommitted_tree()
         stdout, stderr = self.run_bzr("status")
 
@@ -738,8 +727,7 @@
 """)
 
     def test_stdout_latin1(self):
-        sys.stdout = StringIO()
-        osutils._cached_user_encoding = 'latin-1'
+        self.overrideAttr(osutils, '_cached_user_encoding', 'latin-1')
         working_tree = self.make_uncommitted_tree()
         stdout, stderr = self.run_bzr('status')
 

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2010-05-20 18:23:17 +0000
+++ bzrlib/tests/test_errors.py	2010-07-09 16:16:11 +0000
@@ -655,6 +655,11 @@
         str(err)
         self.assertEqual(['open_repository'], fake_bzrdir.calls)
 
+    def test_invalid_pattern(self):
+        error = errors.InvalidPattern('Bad pattern msg.')
+        self.assertEqualDiff("Invalid pattern(s) found. Bad pattern msg.",
+            str(error))
+
 
 class PassThroughError(errors.BzrError):
 

=== modified file 'bzrlib/tests/test_globbing.py'
--- bzrlib/tests/test_globbing.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_globbing.py	2010-07-09 16:16:11 +0000
@@ -15,6 +15,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from bzrlib import errors
 from bzrlib.globbing import (
     Globster,
     ExceptionGlobster,
@@ -308,6 +309,14 @@
             self.assertEqual(patterns[x],globster.match(filename))
         self.assertEqual(None,globster.match('foobar.300'))
 
+    def test_bad_pattern(self):
+        """Ensure that globster handles bad patterns cleanly."""
+        patterns = [u'RE:[']
+        g = Globster(patterns)
+        e = self.assertRaises(errors.InvalidPattern, g.match, 'foo')
+        self.assertContainsRe(e.msg, "File.*ignore.*contains errors")
+
+
 class TestExceptionGlobster(TestCase):
 
     def test_exclusion_patterns(self):

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2010-06-11 10:59:23 +0000
+++ bzrlib/tests/test_http.py	2010-07-13 19:02:12 +0000
@@ -1125,10 +1125,7 @@
     def setUp(self):
         tests.TestCase.setUp(self)
         self._old_env = {}
-
-    def tearDown(self):
-        self._restore_env()
-        tests.TestCase.tearDown(self)
+        self.addCleanup(self._restore_env)
 
     def _install_env(self, env):
         for name, value in env.iteritems():
@@ -1974,13 +1971,8 @@
         # We override at class level because constructors may propagate the
         # bound method and render instance overriding ineffective (an
         # alternative would be to define a specific ui factory instead...)
-        self.orig_report_activity = self._transport._report_activity
-        self._transport._report_activity = report_activity
-
-    def tearDown(self):
-        self._transport._report_activity = self.orig_report_activity
-        self.server.stop_server()
-        tests.TestCase.tearDown(self)
+        self.overrideAttr(self._transport, '_report_activity', report_activity)
+        self.addCleanup(self.server.stop_server)
 
     def get_transport(self):
         return self._transport(self.server.get_url())
@@ -2103,51 +2095,22 @@
 class TestActivity(tests.TestCase, TestActivityMixin):
 
     def setUp(self):
-        tests.TestCase.setUp(self)
-        self.server = self._activity_server(self._protocol_version)
-        self.server.start_server()
-        self.activities = {}
-        def report_activity(t, bytes, direction):
-            count = self.activities.get(direction, 0)
-            count += bytes
-            self.activities[direction] = count
-
-        # We override at class level because constructors may propagate the
-        # bound method and render instance overriding ineffective (an
-        # alternative would be to define a specific ui factory instead...)
-        self.orig_report_activity = self._transport._report_activity
-        self._transport._report_activity = report_activity
-
-    def tearDown(self):
-        self._transport._report_activity = self.orig_report_activity
-        self.server.stop_server()
-        tests.TestCase.tearDown(self)
+        TestActivityMixin.setUp(self)
 
 
 class TestNoReportActivity(tests.TestCase, TestActivityMixin):
 
+    # Unlike TestActivity, we are really testing ReportingFileSocket and
+    # ReportingSocket, so we don't need all the parametrization. Since
+    # ReportingFileSocket and ReportingSocket are wrappers, it's easier to
+    # test them through their use by the transport than directly (that's a
+    # bit less clean but far more simpler and effective).
+    _activity_server = ActivityHTTPServer
+    _protocol_version = 'HTTP/1.1'
+
     def setUp(self):
-        tests.TestCase.setUp(self)
-        # Unlike TestActivity, we are really testing ReportingFileSocket and
-        # ReportingSocket, so we don't need all the parametrization. Since
-        # ReportingFileSocket and ReportingSocket are wrappers, it's easier to
-        # test them through their use by the transport than directly (that's a
-        # bit less clean but far more simpler and effective).
-        self.server = ActivityHTTPServer('HTTP/1.1')
-        self._transport=_urllib.HttpTransport_urllib
-
-        self.server.start_server()
-
-        # We override at class level because constructors may propagate the
-        # bound method and render instance overriding ineffective (an
-        # alternative would be to define a specific ui factory instead...)
-        self.orig_report_activity = self._transport._report_activity
-        self._transport._report_activity = None
-
-    def tearDown(self):
-        self._transport._report_activity = self.orig_report_activity
-        self.server.stop_server()
-        tests.TestCase.tearDown(self)
+        self._transport =_urllib.HttpTransport_urllib
+        TestActivityMixin.setUp(self)
 
     def assertActivitiesMatch(self):
         # Nothing to check here

=== modified file 'bzrlib/tests/test_lazy_regex.py'
--- bzrlib/tests/test_lazy_regex.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_lazy_regex.py	2010-07-09 16:16:11 +0000
@@ -18,6 +18,7 @@
 
 import re
 
+from bzrlib import errors
 from bzrlib import (
     lazy_regex,
     tests,
@@ -63,6 +64,14 @@
                           ('_real_re_compile', ('foo',), {}),
                          ], actions)
 
+    def test_bad_pattern(self):
+        """Ensure lazy regex handles bad patterns cleanly."""
+        p = lazy_regex.lazy_compile('RE:[')
+        # As p.match is lazy, we make it into a lambda so its handled
+        # by assertRaises correctly.
+        e = self.assertRaises(errors.InvalidPattern, lambda: p.match('foo'))
+        self.assertEqual(e.msg, '"RE:[" unexpected end of regular expression')
+
 
 class TestLazyCompile(tests.TestCase):
 

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2010-06-17 14:58:20 +0000
+++ bzrlib/tests/test_osutils.py	2010-07-08 09:11:44 +0000
@@ -27,7 +27,9 @@
 
 from bzrlib import (
     errors,
+    lazy_regex,
     osutils,
+    symbol_versioning,
     tests,
     trace,
     win32utils,
@@ -1705,19 +1707,27 @@
 
 class TestReCompile(tests.TestCase):
 
+    def _deprecated_re_compile_checked(self, *args, **kwargs):
+        return self.applyDeprecated(symbol_versioning.deprecated_in((2, 2, 0)),
+            osutils.re_compile_checked, *args, **kwargs)
+
     def test_re_compile_checked(self):
-        r = osutils.re_compile_checked(r'A*', re.IGNORECASE)
+        r = self._deprecated_re_compile_checked(r'A*', re.IGNORECASE)
         self.assertTrue(r.match('aaaa'))
         self.assertTrue(r.match('aAaA'))
 
     def test_re_compile_checked_error(self):
         # like https://bugs.launchpad.net/bzr/+bug/251352
+
+        # Due to possible test isolation error, re.compile is not lazy at
+        # this point. We re-install lazy compile.
+        lazy_regex.install_lazy_compile()
         err = self.assertRaises(
             errors.BzrCommandError,
-            osutils.re_compile_checked, '*', re.IGNORECASE, 'test case')
+            self._deprecated_re_compile_checked, '*', re.IGNORECASE, 'test case')
         self.assertEqual(
-            "Invalid regular expression in test case: '*': "
-            "nothing to repeat",
+            'Invalid regular expression in test case: '
+            '"*" nothing to repeat',
             str(err))
 
 

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2010-06-20 11:18:38 +0000
+++ bzrlib/tests/test_remote.py	2010-07-13 19:02:12 +0000
@@ -89,10 +89,7 @@
         self.transport = self.get_transport()
         # make a branch that can be opened over the smart transport
         self.local_wt = BzrDir.create_standalone_workingtree('.')
-
-    def tearDown(self):
-        self.transport.disconnect()
-        tests.TestCaseWithTransport.tearDown(self)
+        self.addCleanup(self.transport.disconnect)
 
     def test_create_remote_bzrdir(self):
         b = remote.RemoteBzrDir(self.transport, remote.RemoteBzrDirFormat())

=== modified file 'bzrlib/tests/test_smart_request.py'
--- bzrlib/tests/test_smart_request.py	2010-06-20 11:18:38 +0000
+++ bzrlib/tests/test_smart_request.py	2010-07-13 19:02:12 +0000
@@ -187,9 +187,11 @@
 
 class TestJailHook(TestCaseWithMemoryTransport):
 
-    def tearDown(self):
-        request.jail_info.transports = None
-        TestCaseWithMemoryTransport.tearDown(self)
+    def setUp(self):
+        super(TestJailHook, self).setUp()
+        def clear_jail_info():
+            request.jail_info.transports = None
+        self.addCleanup(clear_jail_info)
 
     def test_jail_hook(self):
         request.jail_info.transports = None

=== modified file 'bzrlib/tests/test_workingtree_4.py'
--- bzrlib/tests/test_workingtree_4.py	2010-02-04 16:06:36 +0000
+++ bzrlib/tests/test_workingtree_4.py	2010-07-13 16:10:20 +0000
@@ -757,3 +757,23 @@
             ('', [(('', 'dir', 'dir-id'), ['d', 'd'])]),
             ('dir', [(('dir', 'file', 'file-id'), ['a', 'f'])]),
         ],  self.get_simple_dirblocks(state))
+
+
+class TestInventoryCoherency(TestCaseWithTransport):
+
+    def test_inventory_is_synced_when_unversioning_a_dir(self):
+        """Unversioning the root of a subtree unversions the entire subtree."""
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['a/', 'a/b', 'c/'])
+        tree.add(['a', 'a/b', 'c'], ['a-id', 'b-id', 'c-id'])
+        # within a lock unversion should take effect
+        tree.lock_write()
+        self.addCleanup(tree.unlock)
+        # Force access to the in memory inventory to trigger bug #494221: try
+        # maintaining the in-memory inventory
+        inv = tree.inventory
+        self.assertTrue(inv.has_id('a-id'))
+        self.assertTrue(inv.has_id('b-id'))
+        tree.unversion(['a-id', 'b-id'])
+        self.assertFalse(inv.has_id('a-id'))
+        self.assertFalse(inv.has_id('b-id'))

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2010-06-20 11:18:38 +0000
+++ bzrlib/workingtree.py	2010-07-06 19:48:05 +0000
@@ -176,6 +176,9 @@
 
     It is possible for a `WorkingTree` to have a filename which is
     not listed in the Inventory and vice versa.
+
+    :ivar basedir: The root of the tree on disk. This is a unicode path object
+        (as opposed to a URL).
     """
 
     # override this to set the strategy for storing views

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2010-05-20 18:23:17 +0000
+++ bzrlib/workingtree_4.py	2010-07-13 16:10:20 +0000
@@ -1247,7 +1247,8 @@
         # have to change the legacy inventory too.
         if self._inventory is not None:
             for file_id in file_ids:
-                self._inventory.remove_recursive_id(file_id)
+                if self._inventory.has_id(file_id):
+                    self._inventory.remove_recursive_id(file_id)
 
     @needs_tree_write_lock
     def rename_one(self, from_rel, to_rel, after=False):

=== modified file 'doc/developers/ppa.txt'
--- doc/developers/ppa.txt	2010-06-30 04:11:36 +0000
+++ doc/developers/ppa.txt	2010-07-13 17:14:43 +0000
@@ -47,6 +47,10 @@
 <lp:~bzr/bzr/packaging-hardy>.  These branches are intended to be used
 with the ``bzr-builddeb`` plugin.
 
+**You should almost always upload to the beta ppa first** and then either 
+upload again or copy the packages into the release ppa.  That reduces the 
+risk of breaking the main archive from which people get bzr updates.
+
 Preconditions
 -------------
 
@@ -55,26 +59,15 @@
 
 * You must have a GPG key registered to your Launchpad account.
 
-* Configure ``dput`` to upload to our PPA with this section in your
-  ``~/.dput.cf``::
-
-    [bzr-beta-ppa]
-    fqdn = ppa.launchpad.net
-    method = ftp
-    incoming = ~bzr-beta-ppa/ubuntu
-    login = anonymous
-    allow_unsigned_uploads = 0
-
-    [bzr-ppa]
-    fqdn = ppa.launchpad.net
-    method = ftp
-    incoming = ~bzr/ubuntu
-    login = anonymous
-    allow_unsigned_uploads = 0
-
-  You may also want to add these lines to prevent inadvertently attempting
-  to upload into Ubuntu or Debian, which will give a somewhat unclear
-  error::
+On reasonably recent versions of Ubuntu you no longer need special dput
+configuration, because you can just say ::
+
+  dput ppa:bzr/2.1-proposed <source.changes
+  
+
+However, you may still want to add these lines to ``~/.dput.cf`` prevent 
+inadvertently attempting to upload into Ubuntu or Debian, which will
+give a somewhat unclear error::
 
     [DEFAULT]
     default_host_main = notspecified
@@ -103,6 +96,31 @@
 Packaging Bazaar
 ----------------
 
+Overview of packaging with builddeb
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+* First update the oldest supported branch, using ``bzr merge-upstream``.
+
+* Run ``bzr builddeb -S -- -sa`` to build a source package, then put 
+  that into the ppa.  
+  
+  (``-S`` says to make a source-only upload, which is
+  required for Launchpad's builders.  ``--sa`` says to include the
+  ``.orig.tgz`` even if this doesn't seem to be the first upload for an
+  upstream release: this is often needed when rebuilding something that's
+  previously been uploaded to Debian or Ubuntu or into a different PPA.)
+
+* Now merge across that change into each supported branch with a 
+  simple ``bzr merge``.
+  
+Locally testing builds
+~~~~~~~~~~~~~~~~~~~~~~
+
+It may be useful to locally test builds inside pbuilder.  You may want to 
+use the script from <http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=255165> 
+to wrap it.
+
+
 Short form
 ~~~~~~~~~~
 
@@ -285,6 +303,16 @@
 summary of current package versions with::
 
   apt-cache madison bzr
+  
+  
+  
+Packaging dependencies
+----------------------
+
+Some of our updates to bzr in previous releases require backports of our
+dependencies.  Specific branches holding these backports:
+
+ * ``lp:~bzr/ubuntu/dapper/configobj/dapper-backport``
 
 
 ..

=== modified file 'doc/developers/testing.txt'
--- doc/developers/testing.txt	2010-07-06 03:44:38 +0000
+++ doc/developers/testing.txt	2010-07-15 09:47:16 +0000
@@ -905,6 +905,26 @@
 Please see bzrlib.treebuilder for more details.
 
 
+Temporarily changing state
+~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+If your test needs to temporarily mutate some global state, and you need
+it restored at the end, you can say for example::
+
+    self.overrideAttr(osutils, '_cached_user_encoding', 'latin-1')
+
+Cleaning up
+~~~~~~~~~~~
+
+Our base ``TestCase`` class provides an ``addCleanup`` method, which
+should be used instead of ``tearDown``.  All the cleanups are run when the
+test finishes, regardless of whether it passes or fails.  If one cleanup
+fails, later cleanups are still run.
+
+(The same facility is available outside of tests through
+``bzrlib.cleanup``.)
+
+
 Manual testing
 ==============
 

=== modified file 'doc/en/user-guide/configuring_bazaar.txt'
--- doc/en/user-guide/configuring_bazaar.txt	2010-06-02 05:03:31 +0000
+++ doc/en/user-guide/configuring_bazaar.txt	2010-07-07 01:55:26 +0000
@@ -16,6 +16,28 @@
 
 If ``whoami`` is used without an argument, the current value is displayed.
 
+Using a network proxy
+---------------------
+
+If your network requires that you use an http proxy for outbound
+connections, you must set the ``http_proxy`` variable.  If the proxy is
+also required for https connections, you need to set ``https_proxy`` too.
+If you need these and don't have them set, you may find that connections
+to Launchpad or other external servers fail or time out.
+
+On Unix you typically want to set these in ``/etc/environment`` or
+``~/.bash_profile`` and on Windows in the user profile.
+
+::
+
+  http_proxy=http://proxy.example.com:3128/
+  https_proxy=http://proxy.example.com:3128/
+
+The ``no_proxy`` variable can be set to a comma-separated list of hosts
+which shouldn't be reached by the proxy.  (See
+<http://docs.python.org/library/urllib.html> for more details.)
+
+
 Configuration files
 -------------------
 

=== modified file 'setup.py'
--- setup.py	2010-07-04 07:09:09 +0000
+++ setup.py	2010-07-05 14:16:45 +0000
@@ -413,19 +413,12 @@
 
 def get_qbzr_py2exe_info(includes, excludes, packages, data_files):
     # PyQt4 itself still escapes the plugin detection code for some reason...
-    packages.append('PyQt4')
-    excludes.append('PyQt4.elementtree.ElementTree')
-    excludes.append('PyQt4.uic.port_v3')
+    includes.append('PyQt4.QtCore')
+    includes.append('PyQt4.QtGui')
     includes.append('sip') # extension module required for Qt.
     packages.append('pygments') # colorizer for qbzr
     packages.append('docutils') # html formatting
     includes.append('win32event')  # for qsubprocess stuff
-    # but we can avoid many Qt4 Dlls.
-    dll_excludes.extend(
-        """QtAssistantClient4.dll QtCLucene4.dll QtDesigner4.dll
-        QtHelp4.dll QtNetwork4.dll QtOpenGL4.dll QtScript4.dll
-        QtSql4.dll QtTest4.dll QtWebKit4.dll QtXml4.dll
-        qscintilla2.dll""".split())
     # the qt binaries might not be on PATH...
     # They seem to install to a place like C:\Python25\PyQt4\*
     # Which is not the same as C:\Python25\Lib\site-packages\PyQt4

